<?php

/**
 * @file
 * @file
 * .*/

/**
 * .
 */
function ebourgogneannuaires_check_api_key($apiKey, $error_message = TRUE) {
  $base_url = EBOU_ANNU_SERVICE_EXTERNAL_CHECK_URL;

  $options = array('headers' => array('ebou-api-key' => $apiKey), 'method' => 'GET');

  $response = drupal_http_request($base_url, $options);

  if ($response->code != 200) {
    variable_set('ebourgogneannuaires_good_api_key', FALSE);

    if ($response->code == 403) {
      if ($error_message) {
        drupal_set_message(t("Votre clé d'API n'est pas valide. Veuillez vérifier si elle correspond bien à celle fournie par e-bourgogne. Si le problème persiste, contactez l'assistance e bourgogne."), 'error');
      }
    }
    else {
      if ($error_message) {
        drupal_set_message(t("Une erreur est survenue lors de la vérification de votre clé d'API. Si le problème persiste, contactez l'assistance e-bourgogne."), 'error');
      }
    }
  }
  else {
    variable_set('ebourgogneannuaires_good_api_key', TRUE);
  }

  variable_set('ebourgogneannuaires_api_key', $apiKey);
}

/**
 * .
 */
function ebourgogneannuaires_retrieve_annuaires($apiKey) {

  $options = array('headers' => array('ebou-api-key' => $apiKey), 'method' => 'GET');

  $organism_id = explode(':', base64_decode($apiKey))[0];

  $base_url = EBOU_ANNU_SERVICE_EXTERNAL_SEARCH_URL . '/?organismId=';
  $base_url .= $organism_id;
  $base_url .= '&page=no&sort=yes';

  $response = drupal_http_request($base_url, $options);

  $annuairesArray = array();

  if ($response->code != 200) {
    if ($response->code == 403) {
      drupal_set_message(t("Votre clé d'API n'est pas valide. Veuillez vérifier si elle correspond bien à celle fournie par e-bourgogne. Si le problème persiste, contactez l'assistance e-bourgogne."), 'error');
      variable_set('ebourgogneannuaires_good_api_key', FALSE);
    }
    else {
      drupal_set_message(t("Une erreur est survenue lors de la récupération des annuaires. Si le problème persiste, contactez l'assistance e-bourgogne."), 'error');
    }
  }
  else {
    $annuaires_json = json_decode($response->data, TRUE);

    $annuairesArray = array();

    foreach ($annuaires_json as $annuaire) {
      $annuairesArray[$annuaire['id']] = $annuaire['title'];
    }

    variable_set('ebourgogneannuaires_annuaires', $annuaires_json);
  }

  return $annuairesArray;

}
